# 新番更新时间表

---

> https://bangumi.bilibili.com/web_api/timeline_global

*请求方式：GET*

鉴权方式：Cookie

**不需要url参数**

**json回复：**

根对象：

| 字段    | 类型 | 内容     | 备注                                        |
| ------- | ---- | -------- | ------------------------------------------- |
| code    | num  | 返回值   | 0：成功<br />-400：请求错误<br />-404：错误 |
| message | str  | 错误信息 | 默认为success                               |
| result  | arr  | 信息本体 |                                             |

`result`数组：

| 项   | 类型 | 内容            | 备注 |
| ---- | ---- | --------------- | ---- |
| 0    | obj  | 日期序号1       |      |
| n    | obj  | 日期序号（n+1） |      |
| ……   | obj  | ……              |      |

`result`数组中的对象：

| 字段       | 类型  | 内容           | 备注                   |
| ---------- | ----- | -------------- | ---------------------- |
| date       | str   | 日期           |                        |
| date_ts    | num   | 时间戳         |                        |
| day_of_week| num   | 星期编号       |                        |
| is_today   | num   | 是否为当天     |                        |
| seasons    | arr   | 番剧列表       |                        |

`result`中的`seasons`数组：

| 项   | 类型 | 内容            | 备注 |
| ---- | ---- | --------------- | ---- |
| 0    | obj  | 番剧序号1       |      |
| n    | obj  | 番剧序号（n+1） |      |
| ……   | obj  | ……              |      |

`seasons`数组中的对象：

| 字段         | 类型  | 内容           | 备注                   |
| ------------ | ----- | -------------- | ---------------------- |
| cover        | str   | 番剧封面url    |                        |
| delay        | num   | 是否延后更新   |                        |
| ep_id        | num   | 更新剧集的epID |                        |
| favorites    | num   | 是否已点赞     | 需要登录               |
| follow       | num   | 是否已追番     | 需要登录               |
| is_published | num   | 是否已更新     |                        |
| pub_index    | str   | 更新剧集编号   |                        |
| pub_time     | str   | 更新时间       |                        |
| pub_ts       | num   | 更新时间戳     |                        |
| season_id    | num   | 番剧的ssID     |                        |
| season_status| num   | 未知功能       |                        |
| square_cover | str   | 更新剧集封面url|                        |
| title        | str   | 番剧名称       |                        |
| url          | str   | 播放地址url    |                        |


**示例：**

在2021年1月25日查询

```shell
curl -G 'https://bangumi.bilibili.com/web_api/timeline_global' \
-b 'SESSDATA=xxx'
```

<details>
<summary>查看响应示例：</summary>

```json
{"code":0,"message":"success","result":[{"date":"1-19","date_ts":1610985600,"day_of_week":2,"is_today":0,"seasons":[{"cover":"http://i0.hdslb.com/bfs/bangumi/image/99aa939d399965129d8d0c50687f0e61f9f2bacd.jpg","delay":0,"ep_id":374331,"favorites":0,"follow":0,"is_published":1,"pub_index":"第2话","pub_time":"00:10","pub_ts":1610986200,"season_id":33059,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/ebedf46ce440766bfba573be362a6d1175c21372.jpg","title":"厨神小当家2（中配）","url":"https://www.bilibili.com/bangumi/play/ss33059"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/99aa939d399965129d8d0c50687f0e61f9f2bacd.jpg","delay":0,"ep_id":374319,"favorites":0,"follow":0,"is_published":1,"pub_index":"第2话","pub_time":"00:10","pub_ts":1610986200,"season_id":34422,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/771f7e80ef71b3844e5ad5c0a3c783c85c475ae2.png","title":"厨神小当家2","url":"https://www.bilibili.com/bangumi/play/ss34422"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/098d58fef696ce295f19878b6035214abece824f.png","delay":0,"ep_id":378374,"favorites":0,"follow":0,"is_published":1,"pub_index":"第2话","pub_time":"00:20","pub_ts":1610986800,"season_id":37498,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/fc9051dbb2f876d9a54baa7bf40260ba53406587.png","title":"碧蓝航线：微速前行！","url":"https://www.bilibili.com/bangumi/play/ss37498"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/0212baa8898d0c819c7fb84015e95b8fca621435.png","delay":0,"ep_id":341088,"favorites":0,"follow":0,"is_published":1,"pub_index":"第15话","pub_time":"01:30","pub_ts":1610991000,"season_id":34423,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/f68e9476bce5c882201a79e9f46c99085e217080.png","title":"阿松 第三季","url":"https://www.bilibili.com/bangumi/play/ss34423"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/8fbd44351aa72f4e837d7143a6f937908223cd57.png","delay":0,"ep_id":375001,"favorites":0,"follow":0,"is_published":1,"pub_index":"第2话","pub_time":"02:00","pub_ts":1610992800,"season_id":37568,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/649db28c6762ab821b90710c6681ddb9aa7f7427.png","title":"来冲浪吧！！美少年！！","url":"https://www.bilibili.com/bangumi/play/ss37568"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/cbf16b39569f75717c8af09985baf566cf739299.png","delay":0,"ep_id":373965,"favorites":0,"follow":1,"is_published":1,"pub_index":"第3话-第4话","pub_time":"02:40","pub_ts":1610995200,"season_id":36177,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/aaea2a985185bf9246be480e736f519404872438.png","title":"工作细胞BLACK","url":"https://www.bilibili.com/bangumi/play/ss36177"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/42fa93fc553d97276812d051cae208c6be414ca6.png","delay":0,"ep_id":330063,"favorites":0,"follow":0,"is_published":1,"pub_index":"第39话","pub_time":"17:55","pub_ts":1611050100,"season_id":32916,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/31220048e2326b8190752b7f3575b4eca5ceb231.png","title":"影之诗","url":"https://www.bilibili.com/bangumi/play/ss32916"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/aecbaaf4e3e36a2796684c2eff8ceb9b0f247c6d.jpg","delay":0,"ep_id":378740,"favorites":0,"follow":0,"is_published":1,"pub_index":"第160话","pub_time":"18:25","pub_ts":1611051900,"season_id":6422,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/1d703634cd3ee35b625bf882f27289db301cae63.jpg","title":"黑色四叶草","url":"https://www.bilibili.com/bangumi/play/ss6422"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/42fa93fc553d97276812d051cae208c6be414ca6.png","delay":0,"ep_id":332773,"favorites":0,"follow":0,"is_published":1,"pub_index":"第39话","pub_time":"18:31","pub_ts":1611052260,"season_id":33086,"season_status":2,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/f218be1ed65cc6a662c136d3f992892284c9def3.png","title":"闇影詩章（僅限台灣地區）","url":"https://www.bilibili.com/bangumi/play/ss33086"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/a35d99961307d0865cc514795d0da51dd7ee9a87.png","delay":0,"ep_id":374344,"favorites":0,"follow":0,"is_published":1,"pub_index":"第3话","pub_time":"20:30","pub_ts":1611059400,"season_id":36289,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/2dae611e424d78fe49f97eb9da17a139c9303cbb.png","title":"剧偶像","url":"https://www.bilibili.com/bangumi/play/ss36289"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/10e0bbc1047b2c45f0f881de334a6f3bfb42a3b6.png","delay":0,"ep_id":374356,"favorites":0,"follow":0,"is_published":1,"pub_index":"第2话","pub_time":"23:00","pub_ts":1611068400,"season_id":36209,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/9220e0815b88da7be023ff2dc68cb67c6a4c032e.png","title":"奇蛋物语 / WONDER EGG PRIORITY","url":"https://www.bilibili.com/bangumi/play/ss36209"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/1c1132fe39bec7d88f62c28d703a095c60b4b072.png","delay":0,"ep_id":374002,"favorites":0,"follow":1,"is_published":1,"pub_index":"第26话","pub_time":"23:30","pub_ts":1611070200,"season_id":36170,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/309651136aa074246e76a00d437519434520f1a6.png","title":"关于我转生变成史莱姆这档事 第二季","url":"https://www.bilibili.com/bangumi/play/ss36170"}]},{"date":"1-20","date_ts":1611072000,"day_of_week":3,"is_today":0,"seasons":[{"cover":"http://i0.hdslb.com/bfs/bangumi/image/48df0069b6b95d2f625515d7b956e2ce89609985.png","delay":0,"ep_id":374369,"favorites":0,"follow":0,"is_published":1,"pub_index":"第2话","pub_time":"00:30","pub_ts":1611073800,"season_id":36287,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/60e49a0c9f70621825087d48f9074dda4f338ba6.png","title":"文豪野犬 汪！","url":"https://www.bilibili.com/bangumi/play/ss36287"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/ef9e96a13766c05103778d3746d569026b62e1c9.png","delay":0,"ep_id":374381,"favorites":0,"follow":0,"is_published":1,"pub_index":"第2话","pub_time":"00:45","pub_ts":1611074700,"season_id":36288,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/7f1953a217be2e8df8d6223d2eeeaf3b94243e01.png","title":"世界魔女出发！","url":"https://www.bilibili.com/bangumi/play/ss36288"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/a7625fc1f4cf13635664c65cf863a2017694b8d4.png","delay":0,"ep_id":374445,"favorites":0,"follow":0,"is_published":1,"pub_index":"第2话","pub_time":"17:35","pub_ts":1611135300,"season_id":36362,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/d647736e0c0d3897904cb325663b4b8e704dc0f2.png","title":"愤怒的审判","url":"https://www.bilibili.com/bangumi/play/ss36362"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/26d602c2c6143db78751bc4847f382e20e376481.png","delay":0,"ep_id":374477,"favorites":0,"follow":0,"is_published":1,"pub_index":"第2话","pub_time":"18:25","pub_ts":1611138300,"season_id":36101,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/c760d81bd8e95af357aa05f44e554642ebb00f77.png","title":"记录的地平线 圆桌崩坏","url":"https://www.bilibili.com/bangumi/play/ss36101"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/3fa7b5f039bad7fb097d4fd7446edf0a108e0faf.png","delay":0,"ep_id":374025,"favorites":0,"follow":0,"is_published":1,"pub_index":"第1话","pub_time":"21:00","pub_ts":1611147600,"season_id":36284,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/73d7487aa02fed319139e152eaff6c8b8fa381d6.png","title":"魔术士欧菲流浪之旅 基姆拉克篇","url":"https://www.bilibili.com/bangumi/play/ss36284"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/4f3edbede7fc0bdb52842075cf8faaa1c5953eaa.png","delay":0,"ep_id":373926,"favorites":0,"follow":0,"is_published":1,"pub_index":"第16话","pub_time":"23:00","pub_ts":1611154800,"season_id":36429,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/65407c71382b940d91bd40c71dbdad2608faed2e.png","title":"Re：从零开始的异世界生活 第二季 后半","url":"https://www.bilibili.com/bangumi/play/ss36429"}]},{"date":"1-21","date_ts":1611158400,"day_of_week":4,"is_today":0,"seasons":[{"cover":"http://i0.hdslb.com/bfs/bangumi/image/c5d6c8ca57598f37ef5a48f428bb31d48d6e57e9.png","delay":0,"ep_id":374491,"favorites":0,"follow":0,"is_published":1,"pub_index":"第3话","pub_time":"00:30","pub_ts":1611160200,"season_id":36291,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/e081b1eff17c1f6c61ac41e9112a16790ba74720.png","title":"装甲娘战机","url":"https://www.bilibili.com/bangumi/play/ss36291"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/18c2bc8245a9f60648b7c8ae6a9a7986a46aeea3.png","delay":0,"ep_id":374506,"favorites":0,"follow":0,"is_published":1,"pub_index":"第3话","pub_time":"01:00","pub_ts":1611162000,"season_id":36283,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/73e4b8cf71c72d85fe98da33c307c23a6de7f8be.png","title":"苍之骑士团","url":"https://www.bilibili.com/bangumi/play/ss36283"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/de1dc90a7fb5456a9db09b0e21b1d04e3a1606cb.png","delay":0,"ep_id":374519,"favorites":0,"follow":0,"is_published":1,"pub_index":"第3话","pub_time":"04:00","pub_ts":1611172800,"season_id":36131,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/0a4bb61b4d16a79ef9cde3470cd8f56c0b26f66d.png","title":"动物狂想曲 / BEASTARS 第二季","url":"https://www.bilibili.com/bangumi/play/ss36131"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/1830ac3beeb4436645bee4e5d6ab26fc39267d90.png","delay":0,"ep_id":374015,"favorites":0,"follow":0,"is_published":1,"pub_index":"第2话","pub_time":"22:30","pub_ts":1611239400,"season_id":36175,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/5ec65209b8218f4759a20cac564bcb7ba4760848.png","title":"Ｄｒ．ＳＴＯＮＥ　石纪元  (第二季)","url":"https://www.bilibili.com/bangumi/play/ss36175"}]},{"date":"1-22","date_ts":1611244800,"day_of_week":5,"is_today":0,"seasons":[{"cover":"http://i0.hdslb.com/bfs/bangumi/image/10c54e07c8a63afe1623c84a89a01df0535c7481.png","delay":0,"ep_id":373938,"favorites":0,"follow":1,"is_published":1,"pub_index":"第3话","pub_time":"00:00","pub_ts":1611244800,"season_id":36202,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/cda2df9e2ebc029a73acefad02c0318563b43bfa.png","title":"天地创造设计部","url":"https://www.bilibili.com/bangumi/play/ss36202"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/f4f8fc26689c0a1ea830b5f21375e8a73778577c.png","delay":0,"ep_id":374531,"favorites":0,"follow":0,"is_published":1,"pub_index":"第3话","pub_time":"01:28","pub_ts":1611250080,"season_id":36166,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/dda6999ee8867f8496f914461f4d175a664429fe.png","title":"五等分的新娘∬","url":"https://www.bilibili.com/bangumi/play/ss36166"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/7f08595775a2ed809e21b42d144e69962b9e5f91.jpg","delay":0,"ep_id":374543,"favorites":0,"follow":0,"is_published":1,"pub_index":"第3话","pub_time":"01:30","pub_ts":1611250200,"season_id":36285,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/e7e3eca55556a2fa06b032c7cd1f3e5f8b6ac6b4.png","title":"2.43清阴高中男子排球社","url":"https://www.bilibili.com/bangumi/play/ss36285"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/f7ef599b52140d77b6e1f09cca3b44646fdf4cb2.png","delay":0,"ep_id":374556,"favorites":0,"follow":0,"is_published":1,"pub_index":"第3话","pub_time":"01:55","pub_ts":1611251700,"season_id":36210,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/0bb8f0b97b92016fdbab1a6e1771865af120c8fc.png","title":"约定的梦幻岛 第二季","url":"https://www.bilibili.com/bangumi/play/ss36210"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/194a2d2605184b0927bde323e6ec03941470614f.jpg","delay":0,"ep_id":380222,"favorites":0,"follow":0,"is_published":1,"pub_index":"第16话","pub_time":"17:29","pub_ts":1611307740,"season_id":34676,"season_status":2,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/1ce616fb072cecc7e9c2b06c9c956379a9ef47ab.png","title":"春日望和安斋由香里的Do YU~NO~ the Radio","url":"https://www.bilibili.com/bangumi/play/ss34676"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/2850e7ec13e856a65832f772151a6087fb94e868.png","delay":0,"ep_id":374608,"favorites":0,"follow":0,"is_published":1,"pub_index":"第3话","pub_time":"20:30","pub_ts":1611318600,"season_id":36165,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/99dee80e43699c995a005f26d793f2d3e7c96882.png","title":"弱势角色友崎君","url":"https://www.bilibili.com/bangumi/play/ss36165"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/f0796e37abac25ba2aa9f23120646aaa9a3d5ea7.png","delay":0,"ep_id":374622,"favorites":0,"follow":1,"is_published":1,"pub_index":"第3话","pub_time":"21:30","pub_ts":1611322200,"season_id":36167,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/61d38dd807c95a5ba8746181c0e05f45856abd63.png","title":"转生成蜘蛛又怎样！","url":"https://www.bilibili.com/bangumi/play/ss36167"}]},{"date":"1-23","date_ts":1611331200,"day_of_week":6,"is_today":0,"seasons":[{"cover":"http://i0.hdslb.com/bfs/bangumi/image/4687322d892ab275a511830b47e6d32174fadf95.png","delay":0,"ep_id":374646,"favorites":0,"follow":0,"is_published":1,"pub_index":"第3话","pub_time":"00:30","pub_ts":1611333000,"season_id":36282,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/f04f5e59f09f73c750fdb2ccac9d69c0c5b08a49.png","title":"巴克·亚罗/BACK ARROW","url":"https://www.bilibili.com/bangumi/play/ss36282"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/341da8f016864155ce916e1f88cd738f17a07e4c.png","delay":0,"ep_id":370330,"favorites":0,"follow":0,"is_published":1,"pub_index":"第17话","pub_time":"01:23","pub_ts":1611336180,"season_id":34420,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/ec1b87b6066d4521532f2058a415cc730be0c975.jpg","title":"王之逆袭：意志的继承者","url":"https://www.bilibili.com/bangumi/play/ss34420"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/91e9534cc55aa1a6dc959e7d6d33bde970208232.png","delay":0,"ep_id":375396,"favorites":0,"follow":0,"is_published":1,"pub_index":"第15话","pub_time":"01:40","pub_ts":1611337200,"season_id":34430,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/5bcc8a4973c614df86a930b1055a98796a2758dd.png","title":"咒术回战","url":"https://www.bilibili.com/bangumi/play/ss34430"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/16d85f3b70872b311582b59e0601e975b452b348.png","delay":0,"ep_id":373951,"favorites":0,"follow":0,"is_published":1,"pub_index":"第3话","pub_time":"02:25","pub_ts":1611339900,"season_id":36208,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/d39f372c15c828e0fcbb6e00e095924c29d147b0.png","title":"重创的伤口 ","url":"https://www.bilibili.com/bangumi/play/ss36208"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/357e75a1fb3e17a80b49f60af35f5d211d639921.jpg","delay":0,"ep_id":369646,"favorites":0,"follow":0,"is_published":1,"pub_index":"第37话","pub_time":"05:30","pub_ts":1611351000,"season_id":33942,"season_status":2,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/01a56659dec4dd58518f31645fa6d3f4bb55754e.png","title":"海獭波乐 5th","url":"https://www.bilibili.com/bangumi/play/ss33942"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/31e89da7dd10dcc30cc4bc23db1cbcc4ef3f7387.png","delay":0,"ep_id":371641,"favorites":0,"follow":0,"is_published":1,"pub_index":"第15话","pub_time":"09:00","pub_ts":1611363600,"season_id":34841,"season_status":2,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/ebf1b487329854fa0148ceedc8d1df843073bf79.png","title":"与汪汪喵喵同居的开心日常","url":"https://www.bilibili.com/bangumi/play/ss34841"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/4ab5cf1efbd1c5883b8f0580cb0304f5452c4665.png","delay":0,"ep_id":341348,"favorites":0,"follow":0,"is_published":1,"pub_index":"第16话","pub_time":"09:30","pub_ts":1611365400,"season_id":34425,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/ae36d43ebe7ea7176d18bab794de3d8930284feb.png","title":"勇者斗恶龙 达伊的大冒险","url":"https://www.bilibili.com/bangumi/play/ss34425"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/44495658be4713cb36d830064596748aff82faae.png","delay":0,"ep_id":341448,"favorites":0,"follow":0,"is_published":1,"pub_index":"第16话","pub_time":"18:00","pub_ts":1611396000,"season_id":34431,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/b626c4fd3ed378eb7758dcd891ca53dc7c2c0ed1.png","title":"半妖的夜叉姬","url":"https://www.bilibili.com/bangumi/play/ss34431"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/38e2a273f528fd01c34f1fc4df0f69c64487efad.png","delay":0,"ep_id":380822,"favorites":0,"follow":0,"is_published":1,"pub_index":"第1052话","pub_time":"19:30","pub_ts":1611401400,"season_id":33378,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/ecc9a64f3f43eb00ee2bf1549b6ab76182cf5f8b.png","title":"名侦探柯南","url":"https://www.bilibili.com/bangumi/play/ss33378"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/039c4e0b14e27c7a9e5cce2f20a6efd3c8909401.png","delay":0,"ep_id":374670,"favorites":0,"follow":0,"is_published":1,"pub_index":"第3话","pub_time":"23:30","pub_ts":1611415800,"season_id":36198,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/dd03bcf429f18826d447cfc5bf74628e40a7046e.png","title":"堀与宫村","url":"https://www.bilibili.com/bangumi/play/ss36198"}]},{"date":"1-24","date_ts":1611417600,"day_of_week":7,"is_today":0,"seasons":[{"cover":"http://i0.hdslb.com/bfs/bangumi/image/cece1d7eaabd0fac10480efec3d879c542247734.png","delay":0,"ep_id":373880,"favorites":0,"follow":1,"is_published":1,"pub_index":"第3话","pub_time":"00:00","pub_ts":1611417600,"season_id":36174,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/e6376aafe146ebc5b3a77f8c6153870e6e864964.png","title":"工作细胞 第二季","url":"https://www.bilibili.com/bangumi/play/ss36174"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/cbf16b39569f75717c8af09985baf566cf739299.png","delay":0,"ep_id":378522,"favorites":0,"follow":1,"is_published":1,"pub_index":"第5话","pub_time":"00:30","pub_ts":1611419400,"season_id":36177,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/aaea2a985185bf9246be480e736f519404872438.png","title":"工作细胞BLACK","url":"https://www.bilibili.com/bangumi/play/ss36177"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/0fea32875a9c2d20549c95c5549af077caeed30a.png","delay":0,"ep_id":373978,"favorites":0,"follow":0,"is_published":1,"pub_index":"第3话","pub_time":"02:00","pub_ts":1611424800,"season_id":36286,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/4a090a0b22d5dd7336c68034c0e45b007169d728.png","title":"怪病医拉姆尼","url":"https://www.bilibili.com/bangumi/play/ss36286"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/13307ebb99ba3c64f12772c289846809f6b3aa1c.png","delay":0,"ep_id":374683,"favorites":0,"follow":0,"is_published":1,"pub_index":"第3话","pub_time":"02:30","pub_ts":1611426600,"season_id":36211,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/b2573e85941a805cf323cbf7c38460a23875c469.png","title":"无限滑板 / SK8 the Infinity","url":"https://www.bilibili.com/bangumi/play/ss36211"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/4e6c505b1b1631c542ea76c3da1ce08bb43faad6.jpg","delay":0,"ep_id":362218,"favorites":0,"follow":0,"is_published":1,"pub_index":"第135话","pub_time":"10:00","pub_ts":1611453600,"season_id":23841,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/5c2f289eac0ec49bc5e6b9483f4191c42ffa2254.jpg","title":"美妙☆频道","url":"https://www.bilibili.com/bangumi/play/ss23841"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/e405119b732643c5ba241b33896e3e30ff90609c.png","delay":0,"ep_id":317594,"favorites":0,"follow":0,"is_published":1,"pub_index":"第38话","pub_time":"10:30","pub_ts":1611455400,"season_id":33045,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/c6f83b8948bffa135f533448be26ec15f5ddb3c8.jpg","title":"甜梦猫","url":"https://www.bilibili.com/bangumi/play/ss33045"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/71d54cae830d32a5af776dcc46632146fbdba868.jpg","delay":0,"ep_id":350492,"favorites":0,"follow":0,"is_published":1,"pub_index":"第183话","pub_time":"17:30","pub_ts":1611480600,"season_id":5978,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/3121473d5dd03a9bcccb8490034207e724e731b3.jpg","title":"博人传 火影忍者新时代","url":"https://www.bilibili.com/bangumi/play/ss5978"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/ffc7ef5483d8eaa0a0579609b006bc07c4e9411d.jpg","delay":0,"ep_id":380227,"favorites":0,"follow":0,"is_published":1,"pub_index":"第138话","pub_time":"18:00","pub_ts":1611482400,"season_id":23882,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/4143c286982fd8f9ad467af7b6e4a74aaee1c026.jpg","title":"智龙迷城","url":"https://www.bilibili.com/bangumi/play/ss23882"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/d6dff876f06775c133bf172f5e74f054cfea3e24.png","delay":0,"ep_id":374040,"favorites":0,"follow":0,"is_published":1,"pub_index":"第5话","pub_time":"22:00","pub_ts":1611496800,"season_id":36281,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/7238cbc13d106a1713636985ba06e56b2d7bb2a2.png","title":"花样滑冰Stars","url":"https://www.bilibili.com/bangumi/play/ss36281"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/3557b7261e17dd4d4a1e5f1f102f0f3cbecd10a0.png","delay":0,"ep_id":373990,"favorites":0,"follow":0,"is_published":1,"pub_index":"第3话","pub_time":"22:30","pub_ts":1611498600,"season_id":36241,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/91892978edda2615108aab8443a5e2e96ea2f188.png","title":"怪物事变","url":"https://www.bilibili.com/bangumi/play/ss36241"}]},{"date":"1-25","date_ts":1611504000,"day_of_week":1,"is_today":1,"seasons":[{"cover":"http://i0.hdslb.com/bfs/bangumi/image/fac74030433beef657d85717478354492c092cfa.png","delay":0,"ep_id":373888,"favorites":0,"follow":1,"is_published":1,"pub_index":"第3话","pub_time":"00:30","pub_ts":1611505800,"season_id":36168,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/0d83b59cb610132916c9c708557a441835bd0732.png","title":"无职转生～到了异世界就拿出真本事～","url":"https://www.bilibili.com/bangumi/play/ss36168"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/3926335134e162b6b3f12b4808265e4b14753152.png","delay":0,"ep_id":374695,"favorites":0,"follow":0,"is_published":1,"pub_index":"第3话","pub_time":"00:30","pub_ts":1611505800,"season_id":36290,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/f50ff6e2f2e9604c2c58cd2b44b9672964bd0add.png","title":"偶像荣耀/IDOLY PRIDE","url":"https://www.bilibili.com/bangumi/play/ss36290"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/3ec497853b0045ee7099d1e4d4a00552ea3aa12a.png","delay":0,"ep_id":374719,"favorites":0,"follow":1,"is_published":0,"pub_index":"第3话","pub_time":"01:35","pub_ts":1611509700,"season_id":36204,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/78040fac01344efbdc011389005d3711fddb4628.png","title":"悠哉日常大王 第三季","url":"https://www.bilibili.com/bangumi/play/ss36204"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/fa7f7fca3bccf564060bedff3e81f53db14dd9ea.png","delay":0,"ep_id":373431,"favorites":0,"follow":0,"is_published":0,"pub_index":"第41话","pub_time":"07:05","pub_ts":1611529500,"season_id":33073,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/0461fa20c8bb42c31f899246facc076d01279fa4.png","title":"女学。～圣女斯克威尔学院～","url":"https://www.bilibili.com/bangumi/play/ss33073"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/86b7857fe724f62e8000c5759b6561cfeb9a2ee7.png","delay":0,"ep_id":373902,"favorites":0,"follow":0,"is_published":0,"pub_index":"第4话","pub_time":"22:30","pub_ts":1611585000,"season_id":36191,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/cd47e2c5b57eb198b46ec4ec150fa871ec71c4ec.png","title":"好比是最终迷宫前的少年到新手村生活一般的故事","url":"https://www.bilibili.com/bangumi/play/ss36191"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/c87869bc63883138e9f561a7c303284f6ed1dc89.png","delay":0,"ep_id":374309,"favorites":0,"follow":0,"is_published":0,"pub_index":"第4话","pub_time":"23:00","pub_ts":1611586800,"season_id":36579,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/d8e2a0adc75fbc7a6c66758d52218772d66c4f29.jpg","title":"赛马娘 第二季","url":"https://www.bilibili.com/bangumi/play/ss36579"}]},{"date":"1-26","date_ts":1611590400,"day_of_week":2,"is_today":0,"seasons":[{"cover":"http://i0.hdslb.com/bfs/bangumi/image/99aa939d399965129d8d0c50687f0e61f9f2bacd.jpg","delay":0,"ep_id":374332,"favorites":0,"follow":0,"is_published":0,"pub_index":"第3话","pub_time":"00:10","pub_ts":1611591000,"season_id":33059,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/ebedf46ce440766bfba573be362a6d1175c21372.jpg","title":"厨神小当家2（中配）","url":"https://www.bilibili.com/bangumi/play/ss33059"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/99aa939d399965129d8d0c50687f0e61f9f2bacd.jpg","delay":0,"ep_id":374320,"favorites":0,"follow":0,"is_published":0,"pub_index":"第3话","pub_time":"00:10","pub_ts":1611591000,"season_id":34422,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/771f7e80ef71b3844e5ad5c0a3c783c85c475ae2.png","title":"厨神小当家2","url":"https://www.bilibili.com/bangumi/play/ss34422"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/098d58fef696ce295f19878b6035214abece824f.png","delay":0,"ep_id":378375,"favorites":0,"follow":0,"is_published":0,"pub_index":"第3话","pub_time":"00:20","pub_ts":1611591600,"season_id":37498,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/fc9051dbb2f876d9a54baa7bf40260ba53406587.png","title":"碧蓝航线：微速前行！","url":"https://www.bilibili.com/bangumi/play/ss37498"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/0212baa8898d0c819c7fb84015e95b8fca621435.png","delay":0,"ep_id":341089,"favorites":0,"follow":0,"is_published":0,"pub_index":"第16话","pub_time":"01:30","pub_ts":1611595800,"season_id":34423,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/f68e9476bce5c882201a79e9f46c99085e217080.png","title":"阿松 第三季","url":"https://www.bilibili.com/bangumi/play/ss34423"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/8fbd44351aa72f4e837d7143a6f937908223cd57.png","delay":0,"ep_id":375002,"favorites":0,"follow":0,"is_published":0,"pub_index":"第3话","pub_time":"02:00","pub_ts":1611597600,"season_id":37568,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/649db28c6762ab821b90710c6681ddb9aa7f7427.png","title":"来冲浪吧！！美少年！！","url":"https://www.bilibili.com/bangumi/play/ss37568"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/42fa93fc553d97276812d051cae208c6be414ca6.png","delay":0,"ep_id":330064,"favorites":0,"follow":0,"is_published":0,"pub_index":"第40话","pub_time":"17:55","pub_ts":1611654900,"season_id":32916,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/31220048e2326b8190752b7f3575b4eca5ceb231.png","title":"影之诗","url":"https://www.bilibili.com/bangumi/play/ss32916"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/aecbaaf4e3e36a2796684c2eff8ceb9b0f247c6d.jpg","delay":0,"ep_id":378741,"favorites":0,"follow":0,"is_published":0,"pub_index":"第161话","pub_time":"18:25","pub_ts":1611656700,"season_id":6422,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/1d703634cd3ee35b625bf882f27289db301cae63.jpg","title":"黑色四叶草","url":"https://www.bilibili.com/bangumi/play/ss6422"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/42fa93fc553d97276812d051cae208c6be414ca6.png","delay":0,"ep_id":332774,"favorites":0,"follow":0,"is_published":0,"pub_index":"第40话","pub_time":"18:30","pub_ts":1611657000,"season_id":33086,"season_status":2,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/f218be1ed65cc6a662c136d3f992892284c9def3.png","title":"闇影詩章（僅限台灣地區）","url":"https://www.bilibili.com/bangumi/play/ss33086"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/a35d99961307d0865cc514795d0da51dd7ee9a87.png","delay":0,"ep_id":374345,"favorites":0,"follow":0,"is_published":0,"pub_index":"第4话","pub_time":"20:30","pub_ts":1611664200,"season_id":36289,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/2dae611e424d78fe49f97eb9da17a139c9303cbb.png","title":"剧偶像","url":"https://www.bilibili.com/bangumi/play/ss36289"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/10e0bbc1047b2c45f0f881de334a6f3bfb42a3b6.png","delay":0,"ep_id":374357,"favorites":0,"follow":0,"is_published":0,"pub_index":"第3话","pub_time":"23:00","pub_ts":1611673200,"season_id":36209,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/9220e0815b88da7be023ff2dc68cb67c6a4c032e.png","title":"奇蛋物语 / WONDER EGG PRIORITY","url":"https://www.bilibili.com/bangumi/play/ss36209"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/1c1132fe39bec7d88f62c28d703a095c60b4b072.png","delay":0,"ep_id":374003,"favorites":0,"follow":1,"is_published":0,"pub_index":"第27话","pub_time":"23:30","pub_ts":1611675000,"season_id":36170,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/309651136aa074246e76a00d437519434520f1a6.png","title":"关于我转生变成史莱姆这档事 第二季","url":"https://www.bilibili.com/bangumi/play/ss36170"}]},{"date":"1-27","date_ts":1611676800,"day_of_week":3,"is_today":0,"seasons":[{"cover":"http://i0.hdslb.com/bfs/bangumi/image/48df0069b6b95d2f625515d7b956e2ce89609985.png","delay":0,"ep_id":374370,"favorites":0,"follow":0,"is_published":0,"pub_index":"第3话","pub_time":"00:30","pub_ts":1611678600,"season_id":36287,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/60e49a0c9f70621825087d48f9074dda4f338ba6.png","title":"文豪野犬 汪！","url":"https://www.bilibili.com/bangumi/play/ss36287"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/ef9e96a13766c05103778d3746d569026b62e1c9.png","delay":0,"ep_id":374382,"favorites":0,"follow":0,"is_published":0,"pub_index":"第3话","pub_time":"00:45","pub_ts":1611679500,"season_id":36288,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/7f1953a217be2e8df8d6223d2eeeaf3b94243e01.png","title":"世界魔女出发！","url":"https://www.bilibili.com/bangumi/play/ss36288"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/a7625fc1f4cf13635664c65cf863a2017694b8d4.png","delay":0,"ep_id":374446,"favorites":0,"follow":0,"is_published":0,"pub_index":"第3话","pub_time":"17:35","pub_ts":1611740100,"season_id":36362,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/d647736e0c0d3897904cb325663b4b8e704dc0f2.png","title":"愤怒的审判","url":"https://www.bilibili.com/bangumi/play/ss36362"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/26d602c2c6143db78751bc4847f382e20e376481.png","delay":0,"ep_id":374478,"favorites":0,"follow":0,"is_published":0,"pub_index":"第3话","pub_time":"18:25","pub_ts":1611743100,"season_id":36101,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/c760d81bd8e95af357aa05f44e554642ebb00f77.png","title":"记录的地平线 圆桌崩坏","url":"https://www.bilibili.com/bangumi/play/ss36101"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/3fa7b5f039bad7fb097d4fd7446edf0a108e0faf.png","delay":0,"ep_id":374026,"favorites":0,"follow":0,"is_published":0,"pub_index":"第2话","pub_time":"21:00","pub_ts":1611752400,"season_id":36284,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/73d7487aa02fed319139e152eaff6c8b8fa381d6.png","title":"魔术士欧菲流浪之旅 基姆拉克篇","url":"https://www.bilibili.com/bangumi/play/ss36284"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/4f3edbede7fc0bdb52842075cf8faaa1c5953eaa.png","delay":0,"ep_id":373927,"favorites":0,"follow":0,"is_published":0,"pub_index":"第17话","pub_time":"23:00","pub_ts":1611759600,"season_id":36429,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/65407c71382b940d91bd40c71dbdad2608faed2e.png","title":"Re：从零开始的异世界生活 第二季 后半","url":"https://www.bilibili.com/bangumi/play/ss36429"}]},{"date":"1-28","date_ts":1611763200,"day_of_week":4,"is_today":0,"seasons":[{"cover":"http://i0.hdslb.com/bfs/bangumi/image/c5d6c8ca57598f37ef5a48f428bb31d48d6e57e9.png","delay":0,"ep_id":374492,"favorites":0,"follow":0,"is_published":0,"pub_index":"第4话","pub_time":"00:30","pub_ts":1611765000,"season_id":36291,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/e081b1eff17c1f6c61ac41e9112a16790ba74720.png","title":"装甲娘战机","url":"https://www.bilibili.com/bangumi/play/ss36291"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/18c2bc8245a9f60648b7c8ae6a9a7986a46aeea3.png","delay":0,"ep_id":374507,"favorites":0,"follow":0,"is_published":0,"pub_index":"第4话","pub_time":"01:00","pub_ts":1611766800,"season_id":36283,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/73e4b8cf71c72d85fe98da33c307c23a6de7f8be.png","title":"苍之骑士团","url":"https://www.bilibili.com/bangumi/play/ss36283"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/de1dc90a7fb5456a9db09b0e21b1d04e3a1606cb.png","delay":0,"ep_id":374520,"favorites":0,"follow":0,"is_published":0,"pub_index":"第4话","pub_time":"04:00","pub_ts":1611777600,"season_id":36131,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/0a4bb61b4d16a79ef9cde3470cd8f56c0b26f66d.png","title":"动物狂想曲 / BEASTARS 第二季","url":"https://www.bilibili.com/bangumi/play/ss36131"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/1830ac3beeb4436645bee4e5d6ab26fc39267d90.png","delay":0,"ep_id":374016,"favorites":0,"follow":0,"is_published":0,"pub_index":"第3话","pub_time":"22:30","pub_ts":1611844200,"season_id":36175,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/5ec65209b8218f4759a20cac564bcb7ba4760848.png","title":"Ｄｒ．ＳＴＯＮＥ　石纪元  (第二季)","url":"https://www.bilibili.com/bangumi/play/ss36175"}]},{"date":"1-29","date_ts":1611849600,"day_of_week":5,"is_today":0,"seasons":[{"cover":"http://i0.hdslb.com/bfs/bangumi/image/10c54e07c8a63afe1623c84a89a01df0535c7481.png","delay":0,"ep_id":373939,"favorites":0,"follow":1,"is_published":0,"pub_index":"第4话","pub_time":"00:00","pub_ts":1611849600,"season_id":36202,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/cda2df9e2ebc029a73acefad02c0318563b43bfa.png","title":"天地创造设计部","url":"https://www.bilibili.com/bangumi/play/ss36202"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/f4f8fc26689c0a1ea830b5f21375e8a73778577c.png","delay":0,"ep_id":374532,"favorites":0,"follow":0,"is_published":0,"pub_index":"第4话","pub_time":"01:28","pub_ts":1611854880,"season_id":36166,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/dda6999ee8867f8496f914461f4d175a664429fe.png","title":"五等分的新娘∬","url":"https://www.bilibili.com/bangumi/play/ss36166"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/7f08595775a2ed809e21b42d144e69962b9e5f91.jpg","delay":0,"ep_id":374544,"favorites":0,"follow":0,"is_published":0,"pub_index":"第4话","pub_time":"01:30","pub_ts":1611855000,"season_id":36285,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/e7e3eca55556a2fa06b032c7cd1f3e5f8b6ac6b4.png","title":"2.43清阴高中男子排球社","url":"https://www.bilibili.com/bangumi/play/ss36285"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/f7ef599b52140d77b6e1f09cca3b44646fdf4cb2.png","delay":0,"ep_id":374557,"favorites":0,"follow":0,"is_published":0,"pub_index":"第4话","pub_time":"01:55","pub_ts":1611856500,"season_id":36210,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/0bb8f0b97b92016fdbab1a6e1771865af120c8fc.png","title":"约定的梦幻岛 第二季","url":"https://www.bilibili.com/bangumi/play/ss36210"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/2850e7ec13e856a65832f772151a6087fb94e868.png","delay":0,"ep_id":374609,"favorites":0,"follow":0,"is_published":0,"pub_index":"第4话","pub_time":"20:30","pub_ts":1611923400,"season_id":36165,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/99dee80e43699c995a005f26d793f2d3e7c96882.png","title":"弱势角色友崎君","url":"https://www.bilibili.com/bangumi/play/ss36165"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/f0796e37abac25ba2aa9f23120646aaa9a3d5ea7.png","delay":0,"ep_id":374623,"favorites":0,"follow":1,"is_published":0,"pub_index":"第4话","pub_time":"21:30","pub_ts":1611927000,"season_id":36167,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/61d38dd807c95a5ba8746181c0e05f45856abd63.png","title":"转生成蜘蛛又怎样！","url":"https://www.bilibili.com/bangumi/play/ss36167"}]},{"date":"1-30","date_ts":1611936000,"day_of_week":6,"is_today":0,"seasons":[{"cover":"http://i0.hdslb.com/bfs/bangumi/image/4687322d892ab275a511830b47e6d32174fadf95.png","delay":0,"ep_id":374647,"favorites":0,"follow":0,"is_published":0,"pub_index":"第4话","pub_time":"00:30","pub_ts":1611937800,"season_id":36282,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/f04f5e59f09f73c750fdb2ccac9d69c0c5b08a49.png","title":"巴克·亚罗/BACK ARROW","url":"https://www.bilibili.com/bangumi/play/ss36282"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/341da8f016864155ce916e1f88cd738f17a07e4c.png","delay":0,"ep_id":370331,"favorites":0,"follow":0,"is_published":0,"pub_index":"第18话","pub_time":"01:23","pub_ts":1611940980,"season_id":34420,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/ec1b87b6066d4521532f2058a415cc730be0c975.jpg","title":"王之逆袭：意志的继承者","url":"https://www.bilibili.com/bangumi/play/ss34420"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/91e9534cc55aa1a6dc959e7d6d33bde970208232.png","delay":0,"ep_id":375397,"favorites":0,"follow":0,"is_published":0,"pub_index":"第16话","pub_time":"01:25","pub_ts":1611941100,"season_id":34430,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/5bcc8a4973c614df86a930b1055a98796a2758dd.png","title":"咒术回战","url":"https://www.bilibili.com/bangumi/play/ss34430"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/16d85f3b70872b311582b59e0601e975b452b348.png","delay":0,"ep_id":373952,"favorites":0,"follow":0,"is_published":0,"pub_index":"第4话","pub_time":"02:25","pub_ts":1611944700,"season_id":36208,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/d39f372c15c828e0fcbb6e00e095924c29d147b0.png","title":"重创的伤口 ","url":"https://www.bilibili.com/bangumi/play/ss36208"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/357e75a1fb3e17a80b49f60af35f5d211d639921.jpg","delay":0,"ep_id":369647,"favorites":0,"follow":0,"is_published":0,"pub_index":"第38话","pub_time":"05:30","pub_ts":1611955800,"season_id":33942,"season_status":2,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/01a56659dec4dd58518f31645fa6d3f4bb55754e.png","title":"海獭波乐 5th","url":"https://www.bilibili.com/bangumi/play/ss33942"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/31e89da7dd10dcc30cc4bc23db1cbcc4ef3f7387.png","delay":0,"ep_id":371642,"favorites":0,"follow":0,"is_published":0,"pub_index":"第16话","pub_time":"09:00","pub_ts":1611968400,"season_id":34841,"season_status":2,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/ebf1b487329854fa0148ceedc8d1df843073bf79.png","title":"与汪汪喵喵同居的开心日常","url":"https://www.bilibili.com/bangumi/play/ss34841"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/4ab5cf1efbd1c5883b8f0580cb0304f5452c4665.png","delay":0,"ep_id":341349,"favorites":0,"follow":0,"is_published":0,"pub_index":"第17话","pub_time":"09:30","pub_ts":1611970200,"season_id":34425,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/ae36d43ebe7ea7176d18bab794de3d8930284feb.png","title":"勇者斗恶龙 达伊的大冒险","url":"https://www.bilibili.com/bangumi/play/ss34425"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/44495658be4713cb36d830064596748aff82faae.png","delay":0,"ep_id":341449,"favorites":0,"follow":0,"is_published":0,"pub_index":"第17话","pub_time":"18:00","pub_ts":1612000800,"season_id":34431,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/b626c4fd3ed378eb7758dcd891ca53dc7c2c0ed1.png","title":"半妖的夜叉姬","url":"https://www.bilibili.com/bangumi/play/ss34431"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/039c4e0b14e27c7a9e5cce2f20a6efd3c8909401.png","delay":0,"ep_id":374671,"favorites":0,"follow":0,"is_published":0,"pub_index":"第4话","pub_time":"23:30","pub_ts":1612020600,"season_id":36198,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/dd03bcf429f18826d447cfc5bf74628e40a7046e.png","title":"堀与宫村","url":"https://www.bilibili.com/bangumi/play/ss36198"}]},{"date":"1-31","date_ts":1612022400,"day_of_week":7,"is_today":0,"seasons":[{"cover":"http://i0.hdslb.com/bfs/bangumi/image/cece1d7eaabd0fac10480efec3d879c542247734.png","delay":0,"ep_id":373881,"favorites":0,"follow":1,"is_published":0,"pub_index":"第4话","pub_time":"00:00","pub_ts":1612022400,"season_id":36174,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/e6376aafe146ebc5b3a77f8c6153870e6e864964.png","title":"工作细胞 第二季","url":"https://www.bilibili.com/bangumi/play/ss36174"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/cbf16b39569f75717c8af09985baf566cf739299.png","delay":0,"ep_id":378523,"favorites":0,"follow":1,"is_published":0,"pub_index":"第6话","pub_time":"00:30","pub_ts":1612024200,"season_id":36177,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/aaea2a985185bf9246be480e736f519404872438.png","title":"工作细胞BLACK","url":"https://www.bilibili.com/bangumi/play/ss36177"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/0fea32875a9c2d20549c95c5549af077caeed30a.png","delay":0,"ep_id":373979,"favorites":0,"follow":0,"is_published":0,"pub_index":"第4话","pub_time":"02:00","pub_ts":1612029600,"season_id":36286,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/4a090a0b22d5dd7336c68034c0e45b007169d728.png","title":"怪病医拉姆尼","url":"https://www.bilibili.com/bangumi/play/ss36286"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/13307ebb99ba3c64f12772c289846809f6b3aa1c.png","delay":0,"ep_id":374684,"favorites":0,"follow":0,"is_published":0,"pub_index":"第4话","pub_time":"02:30","pub_ts":1612031400,"season_id":36211,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/b2573e85941a805cf323cbf7c38460a23875c469.png","title":"无限滑板 / SK8 the Infinity","url":"https://www.bilibili.com/bangumi/play/ss36211"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/4e6c505b1b1631c542ea76c3da1ce08bb43faad6.jpg","delay":0,"ep_id":380824,"favorites":0,"follow":0,"is_published":0,"pub_index":"第136话","pub_time":"10:00","pub_ts":1612058400,"season_id":23841,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/5c2f289eac0ec49bc5e6b9483f4191c42ffa2254.jpg","title":"美妙☆频道","url":"https://www.bilibili.com/bangumi/play/ss23841"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/e405119b732643c5ba241b33896e3e30ff90609c.png","delay":0,"ep_id":317595,"favorites":0,"follow":0,"is_published":0,"pub_index":"第39话","pub_time":"10:30","pub_ts":1612060200,"season_id":33045,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/c6f83b8948bffa135f533448be26ec15f5ddb3c8.jpg","title":"甜梦猫","url":"https://www.bilibili.com/bangumi/play/ss33045"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/71d54cae830d32a5af776dcc46632146fbdba868.jpg","delay":0,"ep_id":350493,"favorites":0,"follow":0,"is_published":0,"pub_index":"第184话","pub_time":"17:30","pub_ts":1612085400,"season_id":5978,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/3121473d5dd03a9bcccb8490034207e724e731b3.jpg","title":"博人传 火影忍者新时代","url":"https://www.bilibili.com/bangumi/play/ss5978"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/ffc7ef5483d8eaa0a0579609b006bc07c4e9411d.jpg","delay":0,"ep_id":380228,"favorites":0,"follow":0,"is_published":0,"pub_index":"第139话","pub_time":"18:00","pub_ts":1612087200,"season_id":23882,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/4143c286982fd8f9ad467af7b6e4a74aaee1c026.jpg","title":"智龙迷城","url":"https://www.bilibili.com/bangumi/play/ss23882"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/d6dff876f06775c133bf172f5e74f054cfea3e24.png","delay":0,"ep_id":374041,"favorites":0,"follow":0,"is_published":0,"pub_index":"第6话","pub_time":"22:00","pub_ts":1612101600,"season_id":36281,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/7238cbc13d106a1713636985ba06e56b2d7bb2a2.png","title":"花样滑冰Stars","url":"https://www.bilibili.com/bangumi/play/ss36281"},{"cover":"http://i0.hdslb.com/bfs/bangumi/image/3557b7261e17dd4d4a1e5f1f102f0f3cbecd10a0.png","delay":0,"ep_id":373991,"favorites":0,"follow":0,"is_published":0,"pub_index":"第4话","pub_time":"22:30","pub_ts":1612103400,"season_id":36241,"season_status":13,"square_cover":"http://i0.hdslb.com/bfs/bangumi/image/91892978edda2615108aab8443a5e2e96ea2f188.png","title":"怪物事变","url":"https://www.bilibili.com/bangumi/play/ss36241"}]}]}
```

</details>
